Package net.sf.saxon.type

## Class AnyItemType

- java.lang.Object
- - net.sf.saxon.type.AnyItemType

- All Implemented Interfaces:
    `ItemType`, `ItemType.WithSequenceTypeCache`

      public class AnyItemType
      extends java.lang.Object
      implements ItemType.WithSequenceTypeCache

  An implementation of ItemType that matches any item (node or atomic value)

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AtomicType` | `getAtomizedItemType()` | Get the item type of the atomic values that will be produced when an item of this type is atomized
    `java.lang.String` | `getBasicAlphaCode()` | Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived.
    `double` | `getDefaultPriority()` | Get the default priority when this ItemType is used as an XSLT pattern
    `Genre` | `getGenre()` | Determine the Genre (top-level classification) of this type
    `static AnyItemType` | `getInstance()` | Factory method to get the singleton instance
    `ItemType` | `getPrimitiveItemType()` | Get the primitive item type corresponding to this item type.
    `int` | `getPrimitiveType()` | Get the primitive type corresponding to this item type.
    `UType` | `getUType()` | Get the corresponding `UType`.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `boolean` | `isAtomicType()` | Determine whether this item type is an atomic type
    `boolean` | `isAtomizable​(TypeHierarchy th)` | Ask whether values of this type are atomizable
    `boolean` | `isPlainType()` | Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
    `boolean` | `matches​(Item item, TypeHierarchy th)` | Test whether a given item conforms to this type
    `SequenceType` | `one()` | Get a sequence type representing exactly one instance of this atomic type
    `SequenceType` | `oneOrMore()` | Get a sequence type representing one or more instances of this atomic type
    `java.lang.String` | `toString()` |
    `SequenceType` | `zeroOrMore()` | Get a sequence type representing one or more instances of this atomic type
    `SequenceType` | `zeroOrOne()` | Get a sequence type representing zero or one instances of this atomic type

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `explainMismatch, getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType, toExportString`

- - ### Method Detail

    - #### getInstance

          public static AnyItemType getInstance()

      Factory method to get the singleton instance
      Returns:
        the singleton instance

    - #### getGenre

          public Genre getGenre()

      Determine the Genre (top-level classification) of this type
      Specified by:
        `getGenre` in interface `ItemType`
      Returns:
        the Genre to which this type belongs, specifically `Genre.ANY`

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Specified by:
        `getUType` in interface `ItemType`
      Returns:
        the smallest UType that subsumes this item type

    - #### isAtomicType

          public boolean isAtomicType()

      Determine whether this item type is an atomic type
      Specified by:
        `isAtomicType` in interface `ItemType`
      Returns:
        true if this is ANY_ATOMIC_TYPE or a subtype thereof

    - #### getBasicAlphaCode

          public java.lang.String getBasicAlphaCode()

      Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived. The codes are designed so that for any two built-in types A and B, alphaCode(A) is a prefix of alphaCode(B) if and only if A is a supertype of B.
      Specified by:
        `getBasicAlphaCode` in interface `ItemType`
      Returns:
        the alphacode for the nearest containing built-in type

    - #### isPlainType

          public boolean isPlainType()

      Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
      Specified by:
        `isPlainType` in interface `ItemType`
      Returns:
        false: this type can match nodes or atomic values

    - #### matches

          public boolean matches​(Item item,
                                 TypeHierarchy th)

      Test whether a given item conforms to this type
      Specified by:
        `matches` in interface `ItemType`
      Parameters:
        `item` - The item to be tested
        `th` -
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### getPrimitiveItemType

          public ItemType getPrimitiveItemType()

      Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.
      Specified by:
        `getPrimitiveItemType` in interface `ItemType`
      Returns:
        the corresponding primitive type

    - #### getPrimitiveType

          public int getPrimitiveType()

      Description copied from interface: `ItemType`
      Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is BuiltInAtomicType.ANY_ATOMIC. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Returns:
        the integer fingerprint of the corresponding primitive type

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Description copied from interface: `ItemType`
      Get the item type of the atomic values that will be produced when an item of this type is atomized
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          public boolean isAtomizable​(TypeHierarchy th)

      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Parameters:
        `th` - The type hierarchy cache
      Returns:
        true unless it is known that these items will be elements with element-only content, in which case return false

    - #### getDefaultPriority

          public double getDefaultPriority()

      Description copied from interface: `ItemType`
      Get the default priority when this ItemType is used as an XSLT pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Returns:
        the default priority

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### one

          public SequenceType one()

      Get a sequence type representing exactly one instance of this atomic type
      Specified by:
        `one` in interface `ItemType.WithSequenceTypeCache`
      Returns:
        a sequence type representing exactly one instance of this atomic type
      Since:
        9.8.0.2

    - #### zeroOrOne

          public SequenceType zeroOrOne()

      Get a sequence type representing zero or one instances of this atomic type
      Specified by:
        `zeroOrOne` in interface `ItemType.WithSequenceTypeCache`
      Returns:
        a sequence type representing zero or one instances of this atomic type
      Since:
        9.8.0.2

    - #### oneOrMore

          public SequenceType oneOrMore()

      Get a sequence type representing one or more instances of this atomic type
      Specified by:
        `oneOrMore` in interface `ItemType.WithSequenceTypeCache`
      Returns:
        a sequence type representing one or more instances of this atomic type
      Since:
        9.8.0.2

    - #### zeroOrMore

          public SequenceType zeroOrMore()

      Get a sequence type representing one or more instances of this atomic type
      Specified by:
        `zeroOrMore` in interface `ItemType.WithSequenceTypeCache`
      Returns:
        a sequence type representing one or more instances of this atomic type
      Since:
        9.8.0.2